include:
  - template: Security/Dependency-Scanning.gitlab-ci.yml
  - template: Security/Container-Scanning.gitlab-ci.yml

stages:
  - test
  - build
  - scan
  - publish

cache:
  key:
    files:
      - package-lock.json
    prefix: cache
  paths:
    - node_modules/

# test:
#   stage: test
#   image: minds/ci-front:14
#   allow_failure: true
#   variables:
#     PUPPETEER_SKIP_CHROMIUM_DOWNLOAD: "true"
#     PUPPETEER_EXECUTABLE_PATH: "/usr/bin/chromium-browser"
#   script:
#     - apk update && apk add chromium
#     - npm i
#     - npm run test

lint:
  stage: test
  image: minds/ci-front:14
  script:
    - npm i
    - npm run lint

build:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:v1.14.0-debug
    entrypoint: [""]
  script:
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:$CI_PIPELINE_ID"

container_scanning:
  stage: scan
  variables:
    DOCKER_IMAGE: $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID

publish:gitref:
  stage: publish
  image: minds/ci:latest
  script:
    - crane auth login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - crane tag $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID $CI_COMMIT_SHA
  except:
    - master

publish:latest:
  stage: publish
  image: minds/ci:latest
  only:
    refs:
      - master
  script:
    - crane auth login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - crane tag $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID latest
